// constructor
function Delicious() {
	this.userAgent = "Foxylicious";
	this.version = "0.7.2";
	this.method = "GET";
  	this.scheme = "https://";
	this.host = "api.del.icio.us/v1/";
	this.port = 80;
	this.username = null;
	this.password = null;
	this.error = false;
	this.async = true;
	this.req = null;
	this.rootNodeAttibutes = false;
	this.headers = [];
	this.responseHandler;
	this.throttled = false;
	this.ConsoleService = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
	this.debug_flag = false;
}

// for debugging
Delicious.prototype.debug = function(str)
{
	if(this.debug_flag)
		this.ConsoleService.logStringMessage("Delicious: " + str);
}

//
Delicious.prototype.setCredentials = function(username, password)
{
	this.username = username;
	this.password = password;
}

// register function with which to handle the response
Delicious.prototype.registerResponseHandler = function(func)
{
	this.responseHandler = func;
}

// send http message, return parsed response
Delicious.prototype.send = function(path)
{
	this.rootNodeAttributes = false;
	
	if(this.throttled)
	{
		this.throttledHandler();
		return false;
	}
	this.req = null;
	
	// build http request message
	var url = this.scheme + this.host + path;
	this.debug(url);
	
	// moz XMLHTTPRequest object
    if (window.XMLHttpRequest)
    {
        this.req = new XMLHttpRequest();
    }
    // IE/Windows ActiveX version
    else if (window.ActiveXObject)
    {
    	this.req = new ActiveXObject("Microsoft.XMLHTTP");
    }
    
    // set response handler
    this.req.onreadystatechange = this.responseHandler;
    
    // open connection
    this.debug("opening " + this.method + ", " + url + ", " + this.async);
    this.req.open(this.method, url, this.async);

	// set headers
  	this.req.setRequestHeader('Authorization', 'Basic ' + base64(this.username + ':' + this.password));
	//this.req.setRequestHeader('User-Agent', this.userAgent + "/" + this.version);
	
	// send request
this.req.send(null);   //DAL bug muss weg
  	
  	
  //	alert(url);	
  	//alert("asdf");
  //	sleep(1000);
  //	alert("vcvb");
  	
  	//return true;

  	//	return false;  // DAL muss weg
	// if not async, handle response now
	if(this.async == false)
	{
		this.debug('not async, and got http status code ' + this.req.status);
        // only if "OK"
        if (this.req.status == 200) 
		{
			//this.debug(this.req.responseText);
			return this.getResult( this.req.responseXML );
		}
		else
		{
			if (this.req.status == 503)
			{
				this.throttled = true;
				this.throttledHandler();
			}
			return false;
		}
		
	}
	return true;
}

Delicious.prototype.throttledHandler = function()
{
	error('You have been throttled for making too many connections to del.icio.us. Please try again later.');
}

// set errors
Delicious.prototype.setError = function(str)
{
	this.error = str;
}

// get errors
Delicious.prototype.getError = function()
{
	return this.error;
}

// parse result xml into js array
Delicious.prototype.getResult = function(xml)
{
	if(!xml){return false;}
	
	var rootNode = xml.documentElement;
	var result = new Array();
	var attributes =  rootNode.attributes;
	
	this.rootNodeAttributes = new Array();
	for(var k = 0; k < attributes.length; k++) {
		this.rootNodeAttributes[ attributes[k].name ] = attributes[k].value;
	}
	
	// if a single element
	if(rootNode.childNodes.length == 0)
	{
		return false;
	}
	// get "recordset"
	else
	{
		for (var i = 0; i < rootNode.childNodes.length; i++)
		{
			if(rootNode.childNodes[i].nodeType == 1)
			{
				attributes = rootNode.childNodes[i].attributes;
				result[i] = new Array();
				for(var k = 0; k < attributes.length; k++) {
					result[i][ attributes[k].name ] = attributes[k].value;
				}
			}
		}
	}
	return result;
}

/*
function: http://del.icio.us/api/posts/dates?
&tag= filter by this tag - optional
returns a list of dates with the number of posts at each date. 
[tag] adds a filter
*/
Delicious.prototype.get_post_dates = function(tag)
{
	// build path and query string
	var queryString = 'posts/dates?'; // action
	
	if(tag)
	{
		queryString += '&tag=' + escape(tag);
	}
	
	// send
	return this.send(queryString);
}

/*
function: http://del.icio.us/api/tags/get?
returns a list of tags the user has used.
*/
Delicious.prototype.get_tags = function()
{
	// build path and query string
	var queryString = 'tags/get?'; // action
	
	// send
	return this.send(queryString);
}

/*
function: http://del.icio.us/api/all
returns all entries.
*/
Delicious.prototype.get_all_posts = function()
{
	// build path and query string
	var queryString = 'posts/all'; // action
	
	// send
	return this.send(queryString);
}


/*
function: http://del.icio.us/api/posts/get?
	&tag= filter by this tag - optional
	&dt= filter by this date
returns a list of posts on a given date, filtered by tag. if no 
date is supplied, most recent date will be used
*/
Delicious.prototype.get_posts = function(tag,dt)
{
	// build path and query string
	var queryString = 'posts/get?'; // action
	
	if(tag)
	{
		queryString += '&tag=' + escape(tag);
	}
	
	if(dt)
	{
		queryString += '&dt=' + escape(dt);
	}
	
	// send
	return this.send(queryString);
}

/*
function: http://del.icio.us/api/posts/recent?
	&tag= filter by this tag - optional
	&count= number of items to retrieve - optional (defaults to 15)
returns a list of most recent posts, possibly filtered by tag.
*/
Delicious.prototype.get_recent_posts = function(tag,count)
{
	// build path and query string
	var queryString = 'posts/recent?'; // action
	
	if(tag)
	{
		queryString += '&tag=' + escape(tag);
	}
	
	if(count)
	{
		queryString += '&count=' + escape(count);
	}
	
	// send
	return this.send(queryString);
}

/*
function: http://del.icio.us/api/posts/update
returns the date when the account was last updated
*/
Delicious.prototype.update = function()
{
	// send
	this.send('posts/update');
	
	/* for some reason, FF doesn't think the result is xml,
	so we need to manually get the date
	
	<?xml version='1.0' standalone='yes'?>
	<update time="2004-12-08T23:36:08Z" />
	*/
	var xml = this.req.responseText;
	var pos1 = xml.indexOf('"');
	var pos2 = xml.lastIndexOf('"');
	var date = xml.substring(pos1+1, pos2);
	//this.debug('update() result: ' + date);
	return date;
}

/*
function: http://del.icio.us/api/posts/add?
	&url= url for post
	&description= description for post
	&extended= extended for post
	&tags= space-delimited list of tags
	&dt= datestamp for post, format "CCYY-MM-DDThh:mm:ssZ"
makes a post to delicious
*/
Delicious.prototype.add_post = function(link, title, content, category, date,noShare)
{
	// build path and query string
	var queryString =
	'posts/add?'					// action
	+ '&url=' + link						// link for post
	+ '&description=' + escape(title)	// description for post
	+ '&extended=' + escape(content)	// extended for post
	+ '&tags=' + escape(category) 		// space-delimited list of tags
	+ '&dt=' + escape(date); 			// datestamp for post, format "CCYY-MM-DDThh:mm:ssZ"
	if (noShare)
	    queryString += '&shared=no';
	else
	    queryString += '&shared=yes';
	this.debug('add_post: ' + queryString);
	// send
	//alert(queryString);
	return this.send(queryString); // muss wieder rein!!!!
}

/*
function: http://del.icio.us/api/tags/rename?
	&old= old tag
	&new= new tag
renames tags across all posts
*
function rename_tag($old_tag,$new_tag)
{
	// build path and query string
	$queryString =
	'/api/tags/rename?' // action
	.'&old='.escape($old_tag)
	.'&new='.escape($new_tag);
	
	// send
	return $this->send($queryString);
}*/

/*
function: http://del.icio.us/api/inbox/get?
		&dt= filter by this date
returns a list of inbox entries
*
function get_inbox($dt)
{
	// build path and query string
	$queryString =
	'/api/inbox/get?' // action
	.'&dt='.escape($dt);
	
	// send
	return $this->send($queryString);
}*/

/*
function: http://del.icio.us/api/inbox/dates?
returns a list of dates containing inbox entries
*
function get_inbox_dates()
{
	// build path and query string
	$queryString =
	'/api/inbox/dates?'; // action
	
	// send
	return $this->send($queryString);
}*/

/*
function: http://del.icio.us/api/inbox/subs?
returns a list of your subscriptions
*
function get_subscriptions()
{
	// build path and query string
	$queryString =
	'/api/inbox/subs?'; // action
	
	// send
	return $this->send($queryString);
}*/

/*
function: http://del.icio.us/api/inbox/sub?
	&user= username
	&tag = tag - optional, leave blank for all posts
adds a subscription
*
function subscribe($user,$tag=false)
{
	// build path and query string
	$queryString =
	'/api/inbox/sub?' // action
	.'&user='.escape($user);
	
	if($tag)
	{
		$queryString .= '&tag='.escape($tag);
	}
	
	// send
	return $this->send($queryString);
}*/

/*
function: http://del.icio.us/api/inbox/unsub?
	&user= username
	&tag = tag - optional, leave blank for all posts
removes a subscription
*
function unsubscribe($user,$tag=false)
{
	// build path and query string
	$queryString =
	'/api/inbox/unsub?' // action
	.'&user='.escape($user);
	
	if($tag)
	{
		$queryString .= '&tag='.escape($tag);
	}
	
	// send
	return $this->send($queryString);
}*/

/*
function: http://del.icio.us/autonome/2004-07-22?
	delete=http%3A%2F%2Fdietrich.ganx4.com%2F
deletes a post
*
function delete_post($date,$url)
{
	// build path and query string
	$queryString =
	'/'.$this->username
	.'/'.$date
	.'?delete='.escape($url);
	
	// send
	return $this->send($queryString);
}*/

// gets bundles
Delicious.prototype.get_all_bundles = function()
{
	// send path and query string
	return this.send('tags/bundles/all');
}

// from: http://blog.quicksurf.com/index.php?p=78
function base64(inp)
{
	var keyStr = "ABCDEFGHIJKLMNOPQRSTUVWXYZ" + //all caps
	"abcdefghijklmnopqrstuvwxyz" + //all lowercase
	"0123456789+/="; // all numbers plus +/=
	var out = ""; //This is the output
	var chr1, chr2, chr3 = ""; //These are the 3 bytes to be encoded
	var enc1, enc2, enc3, enc4 = ""; //These are the 4 encoded bytes
	var i = 0; //Position counter
	
	do { //Set up the loop here
		chr1 = inp.charCodeAt(i++); //Grab the first byte
		chr2 = inp.charCodeAt(i++); //Grab the second byte
		chr3 = inp.charCodeAt(i++); //Grab the third byte
		
		//Here is the actual base64 encode part.
		//There really is only one way to do it.
		enc1 = chr1 >> 2;
		enc2 = ((chr1 & 3) << 4) | (chr2 >> 4);
		enc3 = ((chr2 & 15) << 2) | (chr3 >> 6);
		enc4 = chr3 & 63;
		
		if (isNaN(chr2)) {
			enc3 = enc4 = 64;
		} else if (isNaN(chr3)) {
			enc4 = 64;
		}
		
		//Lets spit out the 4 encoded bytes
		out = out + keyStr.charAt(enc1) + keyStr.charAt(enc2) + keyStr.charAt(enc3) +
		keyStr.charAt(enc4);
		
		// OK, now clean out the variables used.
		chr1 = chr2 = chr3 = "";
		enc1 = enc2 = enc3 = enc4 = "";
	
	} while (i < inp.length); //And finish off the loop
	
	//Now return the encoded values.
	return out;
}
