var taggingmultiplebookmarks = {
  showEditPanel: function(cmd){

    var view = PlacesUIUtils.getViewForNode(document.popupNode);    // XULElement
    var aNode = view.getSelectionNodes();    // nsINavHistoryResultNode
    if (!aNode || aNode.length < 1)
      return;

    var theBundle = window.top.document.getElementById("taggingmultiplebookmarks_bundle");
    if (!theBundle)
      theBundle = document.getElementById("taggingmultiplebookmarks_bundle");

    if (cmd == 'add'){
      var labelInput = theBundle.getString("addTagslabel")
      var labelCheck = theBundle.getString("checkTagslabel")
    }else if (cmd == 'del'){
      var labelInput = theBundle.getString("delTagslabel")
      var labelCheck = theBundle.getString("checkTagslabel")
    }

    var prompts = Components.classes["@mozilla.org/embedcomp/prompt-service;1"]
                        .getService(Components.interfaces.nsIPromptService);
    var check = {value: false};                  // default the checkbox to false
    var input = {value: ""};                  // default the edit field to Bob
    var result = prompts.prompt(null,
                                theBundle.getString("title"),
                                labelInput,
                                input, labelCheck, check);
    // result is true if OK is pressed, false if Cancel. input.value holds the value of the edit field if "OK" was pressed.
    if (!result)
      return;
    if (cmd == 'add')
      this.addTagForBookmarks(input.value ,aNode ,!check.value)
    else if (cmd == 'del')
      this.delTagForBookmarks(input.value ,aNode, !check.value)

  },

  addTagForBookmarks: function(aTags ,aNode, ignoreFolder){
    var uri, tags, flg;
    var txnName ='Add tags'
    var transactions = [];

    if (!aTags || aTags == "")
      return;

    var mTags = aTags.split(',');
    if (mTags.length == 0)
      return;

    //delete the top and space of the end
    for (let i = 0; i < mTags.length; ++i) {
      mTags[i] = mTags[i].replace(/^\s+/,'').replace(/\s+$/,'');
    }

    aNode = this.getSelectedBookmarks(aNode, ignoreFolder);

    for (let i = 0; i < aNode.length; ++i) {
      // Include visible url nodes only
      let child = aNode[i];
      uri = PlacesUtils._uri(child.uri);
      tags = PlacesUtils.tagging.getTagsForURI(uri, {});
      tagsToAdd =[];
      //add tag if not existed.
      for (var j = 0; j < mTags.length; j++){
        //Skip blank
        if (!mTags[j] || mTags[j] == '')
          continue;
        flg = false;
        for (var k = 0; k < tags.length; k++){
          //Check already tagged
          if (mTags[j].toLowerCase() == tags[k].toLowerCase()){
            flg = true;
            break;
          }
        }
        if(!flg)
          tagsToAdd.push(mTags[j]);
      }
      if (tagsToAdd.length > 0)
        transactions.push(PlacesUIUtils.ptm.tagURI(uri, tagsToAdd));
    }
    if (transactions.length > 0) {
      var txn = PlacesUIUtils.ptm.aggregateTransactions(txnName, transactions);
      PlacesUIUtils.ptm.doTransaction(txn);
    }
  },

  delTagForBookmarks: function(aTags ,aNode, ignoreFolder){
    var uri;
    var txnName ='Delete tags'
    var transactions = [];

    if (!aTags || aTags == "")
      return;

    var mTags = aTags.split(',');
    if (mTags.length == 0)
      return;

    //delete the top and space of the end
    for (let i = 0; i < mTags.length; ++i) {
      mTags[i] = mTags[i].replace(/^\s+/,'').replace(/\s+$/,'');
    }

    var tagsToRemove = [];
    //Remove blank tag
    for (let i = 0; i < mTags.length; ++i) {
      if (!mTags[i] || mTags[i] == '')
        continue;
      tagsToRemove.push(mTags[i]);
    }

    aNode = this.getSelectedBookmarks(aNode, ignoreFolder);
    for (let i = 0; i < aNode.length; ++i) {
      // Include visible url nodes only
      let child = aNode[i];
      uri = PlacesUtils._uri(child.uri);
      transactions.push(PlacesUIUtils.ptm.untagURI(uri, tagsToRemove));
    }
    if (transactions.length > 0) {
      var txn = PlacesUIUtils.ptm.aggregateTransactions(txnName, transactions);
      PlacesUIUtils.ptm.doTransaction(txn);
    }
  },
  //
  //選択しているブックマークを列挙する
  getSelectedBookmarks: function(aNode, ignoreFolder) {
    var ret = [];
    for (let i = 0; i < aNode.length; ++i) {
      let childNode = aNode[i];
      if (PlacesUtils.nodeIsBookmark(childNode) || PlacesUtils.nodeIsURI(childNode)){
        ret.push(childNode);
      } if (!ignoreFolder && PlacesUtils.nodeIsFolder(childNode) &&
               !PlacesUtils.nodeIsLivemarkContainer(childNode)){
        ret = ret.concat(this.flatChildNodes(childNode));
      }
    }
    return ret
  },
  //
  //Thanks SCRAPBLOG : [Places] フォルダ内のブックマークを列挙する
  flatChildNodes: function(aNode) {
    var ret = [];
    var parentNode = PlacesUtils.getFolderContents(aNode.itemId).root;
    for (let i = 0; i < parentNode.childCount; i++) {
      let childNode = parentNode.getChild(i);
      if (PlacesUtils.nodeIsBookmark(childNode))
        ret.push(childNode);
      else if (PlacesUtils.nodeIsFolder(childNode) &&
               !PlacesUtils.nodeIsLivemarkContainer(childNode))
        // call this function recursive
        ret = ret.concat(arguments.callee(childNode));
    }
    return ret;
  }
}